﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Windows.Forms;
using Infragistics.Win.UltraWinChart;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
       DataSet ds = new DataSet(); Random rd = new Random(); DataTable table;
        List<ChartData> CD0 = new List<ChartData>();
        List<ChartData> CD1 = new List<ChartData>();
        List<ChartData> CD2 = new List<ChartData>();
        List<ChartData> CD3 = new List<ChartData>();
        List<ChartData> CD4 = new List<ChartData>();
        ChartData cf = new ChartData();
        private void Form1_Load(object sender, EventArgs e)
        {
            // Create the sample data
            table = new DataTable();
            table.Columns.Add("Data", typeof(List<ChartData>));
            table.Columns.Add("ID");
            table.Columns.Add("Type");
           
            for (int i = 0; i < 2; i++)
            {
                ChartData cd = new ChartData();
                cd.timeStamp = DateTime.Now.AddSeconds(i);
                cd.chData = rd.Next(0, 10);
                CD0.Add(cd);
                cd = new ChartData();
                cd = new ChartData();
                cd.timeStamp = DateTime.Now.AddSeconds(i);
                cd.chData = rd.Next(0, 10);
                CD1.Add(cd);
                cd = new ChartData();
                cd = new ChartData();
                cd.timeStamp = DateTime.Now.AddSeconds(i);
                cd.chData = rd.Next(0, 10);
                CD2.Add(cd);
                cd = new ChartData();
                cd = new ChartData();
                cd.timeStamp = DateTime.Now.AddSeconds(i);
                cd.chData = rd.Next(0, 10);
                CD3.Add(cd);
                cd = new ChartData();
                cd.timeStamp = DateTime.Now.AddSeconds(i);
                cd.chData = rd.Next(0, 10);
                CD4.Add(cd);
            }

            table.Rows.Add(new object[] { CD0, Guid.NewGuid().ToString(), "SELECT" });
            table.Rows.Add(new object[] { CD1, Guid.NewGuid().ToString(), "SELECT" });
            table.Rows.Add(new object[] { CD2, Guid.NewGuid().ToString(), "UNKNOWN" });
            table.Rows.Add(new object[] { CD3, Guid.NewGuid().ToString(), "UNKNOWN" });
            table.Rows.Add(new object[] { CD4, Guid.NewGuid().ToString(), "UNKNOWN" });

            this.ultraGrid1.DisplayLayout.Override.DefaultRowHeight = 200;
            this.ultraGrid1.DisplayLayout.Override.DefaultColWidth = 300;
            //this.ultraGrid1.DataSource = table;
        }
       
        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            // Add an unbound column to display the graph.
            var activityColumn = e.Layout.Bands[0].Columns.Insert(0, "Activity");
            activityColumn.CellActivation = Activation.Disabled;
        }
        UltraChart chart;
        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if (e.Row.Cells.Exists("Data"))
            {
                
                List<ChartData> data = e.Row.GetCellValue("Data") as List<ChartData>;

                chart = new UltraChart();
                chart.Data.ZeroAligned = true;
                chart.Name = "chart";
                chart.Height = 100;
                chart.Width = 300;
                chart.ChartType = Infragistics.UltraChart.Shared.Styles.ChartType.StepLineChart;
                chart.DataSource = data;// ds.Tables[e.Row.Index];
                chart.DataBind();
                chart.BorderStyle = BorderStyle.None;
                
                chart.LineChart.EndStyle = Infragistics.UltraChart.Shared.Styles.LineCapStyle.NoAnchor;
                chart.LineChart.StartStyle = Infragistics.UltraChart.Shared.Styles.LineCapStyle.NoAnchor;
                chart.Axis.X.Visible = false;
                chart.Axis.X.Extent = 0;
                //chart.Axis.X.LineThickness = 1;
                chart.Axis.X.LineDrawStyle = Infragistics.UltraChart.Shared.Styles.LineDrawStyle.Solid;
                chart.Axis.X.NumericAxisType = Infragistics.UltraChart.Shared.Styles.NumericAxisType.Linear;
                chart.Axis.X.MajorGridLines.Visible = false; 
                chart.Axis.Y.Extent = 0;
                chart.Axis.Y.Visible = false;
                chart.Axis.X.RangeType = Infragistics.UltraChart.Shared.Styles.AxisRangeType.Automatic;
             //   chart.Axis.X.RangeMin = DateTime.Now.AddSeconds(1).Ticks;
                chart.Axis.X.RangeMax = DateTime.Now.AddSeconds(5).Ticks;

                chart.Axis.Y.RangeMin = -5;
                chart.Axis.Y.RangeMax = 10;
                chart.AutoSizeMode = AutoSizeMode.GrowOnly;
                chart.ColorModel.ModelStyle = Infragistics.UltraChart.Shared.Styles.ColorModels.CustomLinear;
                chart.EnableCrossHair = true;
                

                e.Row.Cells["Activity"].Appearance.ImageBackground = chart.Image;
                
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
          
            for (int i = 0; i < 2; i++)
            {
                ChartData cd = new ChartData();
                cd.timeStamp = DateTime.Now.AddSeconds(i);
                cd.chData = rd.Next(0, 10);
                CD0.Add(cd);
                ChartData cd1 = new ChartData();               
                cd1.timeStamp = DateTime.Now.AddSeconds(i);
                cd1.chData = rd.Next(0, 10);
                CD1.Add(cd1);
                ChartData cd2 = new ChartData();
                cd2.timeStamp = DateTime.Now.AddSeconds(i);
                cd2.chData = rd.Next(0, 10);
                CD2.Add(cd2);
                ChartData cd3 = new ChartData();
                cd3.timeStamp = DateTime.Now.AddSeconds(i);
                cd3.chData = rd.Next(0, 10);
                CD3.Add(cd3);
                ChartData cd4 = new ChartData();
                cd4.timeStamp = DateTime.Now.AddSeconds(i);
                cd4.chData = rd.Next(0, 10);
                CD4.Add(cd4);
            }
            if (CD1.Count > 6)
            {
                CD0.RemoveRange(0, CD0.Count - 2);
                CD1.RemoveRange(0, CD1.Count - 2);
                CD2.RemoveRange(0, CD2.Count - 2);
                CD3.RemoveRange(0, CD3.Count - 2);
                CD4.RemoveRange(0, CD4.Count - 2);
            }
            if (ultraOptionSet1.CheckedIndex==0)
            {
               
                table.Rows[0][0] = CD0;
                table.Rows[1][0] = CD1;
                table.Rows[2][0] = CD2;
                table.Rows[3][0] = CD3;
                table.Rows[4][0] = CD4;
                this.ultraGrid1.DataSource = table;
            }
            else if (ultraOptionSet1.CheckedIndex==1)
            {
                ultraGrid1.Rows[0].Cells["Data"].Value = CD0;
                this.ultraGrid1.Rows[0].Refresh(RefreshRow.ReloadData);
                ultraGrid1.Rows[1].Cells["Data"].Value = CD1;
                ultraGrid1.Rows[2].Cells["Data"].Value = CD2;
                ultraGrid1.Rows[3].Cells["Data"].Value = CD3;
                ultraGrid1.Rows[4].Cells["Data"].Value = CD4;
            }
        }
    }
}
